Apps that use ArcGIS API for JavaScript 3.x vs 4.x

2189
10
01-15-2020 04:42 PM

Apps that use ArcGIS API for JavaScript 3.x vs 4.x

StoryMaps

The new StoryMaps uses ArcGIS API for JavaScript 4.x. Classic Story Maps continues to use ArcGIS API for JavaScript 3.x.

Web AppBuilder

Web AppBuilder currently uses ArcGIS API for JavaScript 3.x for apps built for web maps. Experience Builder, currently in Beta, uses ArcGIS API for JavaScript 4.x

ArcGIS Dashboards

ArcGIS Dashboards currently uses ArcGIS API for JavaScript 3.x. ArcGIS Dashboards Beta uses ArcGIS API for JavasScript 4.x.

Map Viewer

Map Viewer (classic) uses ArcGIS API for JavaScript 3.x. Map Viewer Beta uses ArcGIS API for JavaScript 4.x.

Configurable Apps

App

 JSAPI 3x

 JSAPI 4x

3D Data Visualization
Attachment Viewer
Basic Viewer 
Category Gallery
Compare
Crowdsource Manager
Crowdsource Polling
Crowdsource Reporter
Directions
Edit
Elevation Profile
Filter
Geo List (Beta)
GeoForm

Image Mask

Image Visit
Imagery Viewer
Impact Summary
Information Lookup
Interactive Legend
Layer Showcase
Live Maps (beta)
Local Perspective
Map Styler
Media Map
Minimal Gallery
Minimalist
Nearby
Public Information
Scene Styler
Scene with Inset Map
Simple Scene Viewer
Story Map Basic
Story Map Cascade
Story Map Journal
Story Map Series
Story Map Shortlist
Story Map Swipe and Spyglass
Story Map Tour
Summary Viewer
Time Aware
Zone Lookup
Comments

Can you add which version of Arcade each app is using (to help support the information in Frequently Asked Questions | ArcGIS for Developers), and when will a functional equivalent to the Information Lookup application be available with the latest version of Arcade?  I would love to be able to access a list of items from a related table in the Information Lookup application, but that doesn't seem to be supported in the app at this point   so at best, I can make a URL to the map with that layer opened. The downside is I don't have edit permissions on the map, so I can't set up URL parameters for it based on a unique ID.

Hi Alison - both the 3x JSAPI and 4x JSAPI use the latest version of Arcade. Apps built using the JSAPI will automatically pick up support from the API. It may be best to post the specific issue you're seeing in the configurable apps forum: ArcGIS Configurable Apps. There may be an app specific issue rather something related to the version of Arcade.

Cheers, 

Chris

So if I got this right, web maps created with the new Map Viewer won't work with apps using API 3.x? At least not new functionality?

For many users it will make it kind of useless for at least a couple of years. The web map mostly is consumed by an app for example WAB, then you have to switch to Experinece Builder to use the new maps, but the Experince builder lacks so much functionalty that it'll probably takes a couple of years until it can actually replace WAB.

Hi Mattias, maps created with the new Map Viewer are expected to work with apps using JSAPI 3x. However, as you mentioned, there are some spots where new functionality is not supported in 3x (details can be found at Compatibility Guide for web maps created with Map Viewer (classic) and Map Viewer Beta. There will be some trade-offs when considering which app to use for a particular map (for ex, a map with dot density or multiple popup elements are best displayed in a 4x app). Here is a higher-level post about web maps created in map viewer beta: Web maps and Map Viewer Beta .

Are you thinking of any specific feature that won't be available in Experience builder? It uses the 4x JSAPI, same as map viewer beta so new feature support should be the same for the most part (and should evolve at the same pace as well).

Cheers,

Chris

Hi Chris, thanks for your reply. I had not seen that blog post before, that was interesting reading.

When it comes to specific features, one feature many users have longed for is grouping layers. It's supposed to be avalible soon in the new Map Viewer, I assume that will be a new feature that's not supported by JSAPI 3.x apps. That would be a reason for going for the new map viewer and the Experience Builder. But the Experience Builder has about 20 avalible widgets while Web App Builder has about 70. Many of EBs 20 widgets are layout widgets or widgets to add different element such as text, images, buttons etc. which makes EB looks more like another variant of Story Maps than a successor to WAB regarding GIS-functionality.
So there's not just a few specific features that EB lacks, there's a lot and therefore i assume it will take pretty long time before they're all implemented in the EB.

Hi Mattias, you raise good points. It might be best to post this in the WAB  / EB forum. There will be some spots where app level integration is necessary on top of what JSAPI supports (either version)..it will vary app to app. For web apps that have their own extensible framework, there may be some rollout over time for specific areas. In most web apps, jsapi support is sufficient. For a prominent, much requested feature like group layers, expect to hear more from the various apps as we get closer to release.

Cheers,

Chris

On this topic... do we know if there are plans or a timeline to update any of the ArcGIS Solutions apps to the 4.x JSAPI? I'm wondering specifically about Crowdsource Manager/Reporter. I'm hoping to use the updated functionality showing related tables in pop-ups. Thank you --

Hi Brittany Burson‌, sorry for the slow response. I don't know of specific plans for the ArcGIS Solutions apps but the expectation would be that they would be migrated as well. It might be to post this in the configurable apps forum - they should be able to provide a more specific answer there.

Cheers,

Chris

We need labels that allow carriage returns (aka mulit-lines, TextFormatting.NewLine, etc. ) in WAB / AGOL / Portal.

Is it true this is not possible in 3.x?

I've also read you can make labels  look as pretty as you want in the new 4.x map viewer, but when you present it to your users in an existing Dashboard (not beta) or Web App, none of your labels will look the same... is that true?

re:

Multi-line labels | ArcGIS API for JavaScript 4.16 

That is correct, 3.x JSAPI based apps like WAB will not support this multi-line formatting 

Version history
Revision #:
1 of 1
Last update:
‎01-15-2020 04:42 PM
Updated by:
 
Contributors